{{ define "title" }}
  {{ $data := index .Site.Data.projects (split .Params.Path_With_Namespace "/") }}
  <h1 class="h2">
    {{ with $data.project.avatar_url }}
      <img src="{{ . }}" alt="Avatar_URL" class="img-thumbnail avatar" />
    {{ end }}
    {{ $data.project.name }}
    <i
      class="fas fa-{{ if eq $data.project.visibility " public" }}
        globe
      {{ else }}
        lock
      {{ end }}"></i>
    {{ if $data.project.empty_repo }}
      <i
        class="fas fa-folder-open"
        data-bs-toggle="tooltip"
        data-bs-placement="top"
        title="Empty repo"></i>
    {{ end }}
  </h1>
{{ end }}

{{ define "main" }}
  {{ $data := index .Site.Data.projects (split .Params.Path_With_Namespace "/") }}
  <p><strong>Description:</strong> {{ $data.project.description }}</p>
  <p><strong>Project ID:</strong> {{ int $data.project.id }}</p>
  <p>
    <strong><i class="fas fa-link fa-fw"></i> Links:</strong>
    <a href="{{ $data.project.web_url }}">[Project]</a>
    <a href="{{ $data.project.web_url }}/-/security/vulnerability_report">[Vulnerability Report]</a>
    <a href="{{ $data.project.web_url }}/-/security/dashboard">[Security Dashboard]</a>
    <a href="{{ $data.project.web_url }}/-/dependencies">[Dependencies]</a>
  </p>

  {{ with .Params.Categories }}
    <div class="card my-4">
      <h2 class="card-header">Categories</h2>
      <div class="card-body">
        <p class="card-text">
          {{ range . }}
            {{ partial "category.html" (dict "Permalink" (printf "categories/%s" . | urlize | relURL) "Title" .) }}
          {{ end }}
        </p>
      </div>
    </div>
  {{ end }}

  {{ with $data.properties.urls }}
    <div class="card my-4">
      <h2 class="card-header">URLs</h2>
      {{ partial "urls.html" . }}
    </div>
  {{ end }}

  {{ $path_with_namespace := .Params.Path_With_Namespace }}
  {{ with $data.violations.result }}
    <div class="card my-4">
      <h2 class="card-header">Policy violations</h2>
      <ul class="list-group list-group-flush">
        {{ range (where site.Data.violations "path_with_namespace" $path_with_namespace) }}
          <li class="list-group-item">
            {{ partial "violation.html" . }}
          </li>
        {{ end }}
      </ul>
    </div>
  {{ end }}

  {{ with $data.vulnerabilities }}
    {{ $detected_and_confirmed_vulnerabilities := (where . "state" "in" "[detected,confirmed]") }}


    <h2>Vulnerabilities</h2>

    {{ $vulns := dict }}
    {{ range (slice "critical" "high" "unknown" "medium" "low" "info") }}
      {{ $vulns = merge $vulns (dict . (len (where $detected_and_confirmed_vulnerabilities "severity" .))) }}
    {{ end }}
    {{ partial "vulnerabilities/metrics.html" $vulns }}


    <div class="card my-4">
      <h3 class="card-header">Last 100 dismissed vulnerabilities</h3>
      <table class="card-table table table-striped">
        <thead>
          <tr>
            <th scope="col">Severity</th>
            <th scope="col">Title</th>
            <th scope="col">Created at</th>
            <th scope="col">Dismissed at</th>
            <th scope="col">Dismissed by</th>
            <th scope="col">Idenfifiers</th>
            <th scope="col">Location</th>
          </tr>
        </thead>
        <tbody>
          {{ range first 100 (sort (where . "state" "dismissed") "dismissed_at" "desc") }}
            <tr>
              <td>{{ partial "severity" .severity }}</td>
              <td>
                <a href="{{ $data.project.web_url }}/-/security/vulnerabilities/{{ .id | urlize }}"
                  >{{ .title }}</a
                >
              </td>
              <td>{{ .created_at | time.Format ":date_medium" }}</td>
              <td>
                {{ with .dismissed_at }}
                  {{ . | time.Format ":date_medium" }}
                {{ else }}
                  Unknown
                {{ end }}
              </td>
              <td>
                {{ with .dismissed_by_id }}
                  {{ partialCached "user.html" . }}
                {{ else }}
                  Unknown
                {{ end }}
              </td>
              <td>
                <ul>
                  {{ range .identifiers }}
                    <li><a href="{{ .url | urlize }}">{{ .name }}</a></li>
                  {{ end }}
                </ul>
              </td>
              <td>
                {{ .location.file }}{{ with .location.start_line }}
                  :{{ . }}
                {{ end }}{{ with .location.end_line }}-{{ . }}{{ end }}
              </td>
            </tr>
          {{ end }}
        </tbody>
      </table>
    </div>

    <div class="card my-4">
      <h3 class="card-header">Last 100 resolved vulnerabilities</h3>
      <table class="card-table table table-striped">
        <thead>
          <tr>
            <th scope="col">Severity</th>
            <th scope="col">Title</th>
            <th scope="col">Created at</th>
            <th scope="col">Resolved at</th>
            <th scope="col">Resolved by</th>
            <th scope="col">Idenfifiers</th>
            <th scope="col">Location</th>
          </tr>
        </thead>
        <tbody>
          {{ range first 100 (sort (where . "state" "resolved") "resolved_at" "desc") }}
            <tr>
              <td>{{ partial "severity" .severity }}</td>
              <td>
                <a href="{{ $data.project.web_url }}/-/security/vulnerabilities/{{ .id | urlize }}"
                  >{{ .title }}</a
                >
              </td>
              <td>{{ .created_at | time.Format ":date_medium" }}</td>
              <td>
                {{ with .resolved_at }}
                  {{ . | time.Format ":date_medium" }}
                {{ else }}
                  Unknown
                {{ end }}
              </td>
              <td>
                {{ with .resolved_by_id }}
                  {{ partialCached "user.html" . }}
                {{ else }}
                  Unknown
                {{ end }}
              </td>
              <td>
                <ul>
                  {{ range .identifiers }}
                    <li><a href="{{ .url | urlize }}">{{ .name }}</a></li>
                  {{ end }}
                </ul>
              </td>
              <td>
                {{ .location.file }}{{ with .location.start_line }}
                  :{{ . }}
                {{ end }}{{ with .location.end_line }}-{{ . }}{{ end }}
              </td>
            </tr>
          {{ end }}
        </tbody>
      </table>
    </div>

    {{ if gt (len (where $detected_and_confirmed_vulnerabilities "severity" "in" "[critical,high,unknown]")) 0 }}
      <div class="card my-4">
        <h3 class="card-header">Top 10s oldest vulnerabilities</h3>
        <table class="card-table table table-striped">
          <thead>
            <tr>
              <th scope="col">Severity</th>
              <th scope="col">Title</th>
              <th scope="col">Created at</th>
              <th scope="col">Idenfifiers</th>
              <th scope="col">Location</th>
              <th scope="col">Status</th>
            </tr>
          </thead>
          <tbody>
            {{ range first 10 (sort (where $detected_and_confirmed_vulnerabilities "severity" "eq" "critical")
              "created_at")
            }}
              <tr>
                <td>{{ partial "severity" .severity }}</td>
                <td>
                  <a
                    href="{{ $data.project.web_url }}/-/security/vulnerabilities/{{ .id | urlize }}"
                    >{{ .title }}</a
                  >
                </td>
                <td>{{ .created_at | time.Format ":date_medium" }}</td>
                <td>
                  <ul>
                    {{ range .identifiers }}
                      <li><a href="{{ .url | urlize }}">{{ .name }}</a></li>
                    {{ end }}
                  </ul>
                </td>
                <td>
                  {{ .location.file }}{{ with .location.start_line }}
                    :{{ . }}
                  {{ end }}{{ with .location.end_line }}-{{ . }}{{ end }}
                </td>
                <td>
                  {{ .state }}
                  {{ if .resolved_on_default_branch }}
                    <i
                      class="fas fa-wrench"
                      data-bs-toggle="tooltip"
                      data-bs-placement="top"
                      title="Resolved on default branch"></i>
                  {{ end }}
                </td>
              </tr>
            {{ end }}
            {{ range first 10 (sort (where $detected_and_confirmed_vulnerabilities "severity" "eq" "high")
              "created_at")
            }}
              <tr>
                <td>{{ partial "severity" .severity }}</td>
                <td>
                  <a
                    href="{{ $data.project.web_url }}/-/security/vulnerabilities/{{ .id | urlize }}"
                    >{{ .title }}</a
                  >
                </td>
                <td>{{ .created_at | time.Format ":date_medium" }}</td>
                <td>
                  <ul>
                    {{ range .identifiers }}
                      <li><a href="{{ .url | urlize }}">{{ .name }}</a></li>
                    {{ end }}
                  </ul>
                </td>
                <td>
                  {{ .location.file }}{{ with .location.start_line }}
                    :{{ . }}
                  {{ end }}{{ with .location.end_line }}-{{ . }}{{ end }}
                </td>
                <td>{{ .state }}</td>
              </tr>
            {{ end }}
            {{ range first 10 (sort (where $detected_and_confirmed_vulnerabilities "severity" "eq" "unknown")
              "created_at")
            }}
              <tr>
                <td>{{ partial "severity" .severity }}</td>
                <td>
                  <a
                    href="{{ $data.project.web_url }}/-/security/vulnerabilities/{{ .id | urlize }}"
                    >{{ .title }}</a
                  >
                </td>
                <td>{{ .created_at | time.Format ":date_medium" }}</td>
                <td>
                  <ul>
                    {{ range .identifiers }}
                      <li><a href="{{ .url | urlize }}">{{ .name }}</a></li>
                    {{ end }}
                  </ul>
                </td>
                <td>
                  {{ .location.file }}{{ with .location.start_line }}
                    :{{ . }}
                  {{ end }}{{ with .location.end_line }}-{{ . }}{{ end }}
                </td>
                <td>{{ .state }}</td>
              </tr>
            {{ end }}
          </tbody>
        </table>
      </div>
    {{ end }}
  {{ end }}

  {{ with $data.dependencies }}
    <div class="card my-4">
      <h2 class="card-header">Dependencies ({{ len . | lang.FormatNumber 0 }})</h2>
      <div class="table-fixed">
        <table class="card-table table table-striped">
          <thead>
            <tr>
              <th scope="col">Component</th>
              <th scope="col">Packager</th>
              <th scope="col">Location</th>
              <th scope="col">Licenses</th>
              <th scope="col">Linked project</th>
            </tr>
          </thead>
          <tbody>
            {{ range (sort (sort . "dependency_file_path") "path_with_namespace") }}
              <tr>
                <td scope="row">{{ .name }} {{ .version }}</td>
                <td>{{ .package_manager }}</td>
                <td>{{ .dependency_file_path }}</td>
                <td>
                  {{ range $i, $license := .licenses }}
                    {{ if $i }}<br />{{ end }}
                    {{ if eq $license.url "" }}
                      {{ $license.name }}
                    {{ else }}
                      <a href="{{ $license.url }}" target="_blank">{{ $license.name }}</a>
                    {{ end }}
                  {{ end }}
                </td>
                <td>
                  {{ with .path_with_namespace }}
                    <a href="{{ printf "projects/%s" . | urlize | relURL }}">{{ . }}</a>
                  {{ end }}&nbsp;
                </td>
              </tr>
            {{ end }}
          </tbody>
        </table>
      </div>
    </div>
  {{ end }}

  {{ with (index $data "images-requested") }}
    {{ with .images }}
      <h2>
        Docker images used
        ({{ len . | lang.FormatNumber 0 }}
        image{{ if gt (len .) 1 }}s{{ end }}
        in the last 3 months)
      </h2>
      {{ range $image, $values := . }}
        {{ $counter := 0 }}
        <h4 class="card-header">{{ partial "images_requested_link" $image }}</h4>
        <div class="table">
          <table class="card-table table table-striped">
            <thead>
              <tr>
                <th scope="col">#</th>
                <th scope="col">Job name</th>
                <th scope="col">Last job id</th>
                <th scope="col">Digest</th>
                <th scope="col">Last used on</th>
              </tr>
            </thead>
            <tbody>
              {{ range (sort (sort . "job_name" "asc") "last_used_at" "desc") }}
                {{ $counter = add $counter 1 }}
                <tr>
                  <th scope="row">{{ int $counter }}</th>
                  <td>
                    <a href="{{ $data.project.web_url }}/-/jobs/{{ int .last_job_id }}"
                      >{{ .job_name }}</a
                    >
                  </td>
                  <td>
                    <a href="{{ $data.project.web_url }}/-/jobs/{{ int .last_job_id }}"
                      >{{ int .last_job_id }}</a
                    >
                  </td>
                  <td>
                    {{ .digest }}
                    {{ if .digest_used }}
                      <i
                        class="fas fa-check-circle"
                        data-bs-toggle="tooltip"
                        title="Digest was used
                      when pulling the image"></i>
                    {{ end }}
                  </td>
                  <td>
                    <span
                      data-bs-toggle="tooltip"
                      data-bs-placement="top"
                      title="{{ .last_used_at | time.Format ":date_full" }}"
                      >{{ .last_used_at | time.Format ":date_medium" }}</span
                    >
                  </td>
                </tr>
              {{ end }}
            </tbody>
          </table>
        </div>
      {{ end }}
    {{ end }}
  {{ end }}
{{ end }}
